UPDATE-ALTERNATIVES(8)

NAME
update-alternatives - Verwaltung symbolischer Links zur Bestimmung von Standardwerten fr Kommandos

BERSICHT
update-alternatives [options] --install link name pfad prioritt [--slave link name pfad]...

update-alternatives [options] --remove name pfad

update-alternatives [options] --remove-all name

update-alternatives [options] --all

update-alternatives [options] --auto name

update-alternatives [options] --display name

update-alternatives [options] --list name

update-alternatives [options] --config name

update-alternatives [options] --set name pfad

BESCHREIBUNG
update-alternatives erzeugt, entfernt, verwaltet und zeigt die Informationen ber die symbolischen Links, die das Debian Alternativ-System bilden, an.

Es ist mglich, mehrere Programme, die die gleiche oder hnliche Funktionalitt bereitstellen, gleichzeitig auf einem System zu installieren. Beispielsweise sind auf vielen Systemen mehrere Texteditoren gleichzeitig installiert. Dies gibt den Benutzern eines Systems die Mglichkeit, falls gewnscht, jeweils einen anderen Editor zu verwenden, allerdings wird es damit fr ein Programm schwierig, gut einen Editor zum Starten auszuwhlen, falls der Benutzer keine spezielle Wahl getroffen hat.

Debian's Alternativ-System hat das Ziel, dieses Problem zu lsen. Ein generischer Name im Dateisystem wird von allen Dateien, die austauschbare Funktionalitt bereitstellen, verwendet. Das Alternativ-System bestimmt zusammen mit dem Systemadministrator welche Datei tatschlich durch diesen generischen Namen referenziert wird. Falls beispielsweise sowohl der Texteditor ed(1) als auch nvi(1) im System installiert sind, wird das Alternative-System dafr sorgen, dass der generische Name /usr/bin/editor standardmig auf /usr/bin/nvi zeigt. Der Systemandministrator kann dies ndern und dafr sorgen, dass er stattdessen auf /usr/bin/ed zeigt, und das Alternativ-System wird diese Einstellung nicht verndern, bis es explizit dazu aufgefordert wird.

Der generische Name ist nicht ein direkter symbolischer Link auf die ausgewhlte Alternative. Stattdessen ist es ein symbolischer Link auf das Alternativ-Verzeichnis, welches wiederum ein symbolischer Link auf die tatschlich referenzierte Datei ist. Dies ist so realisiert, damit die nderungen des Systemadministrators auf das /etc Verzeichnis beschrnkt bleiben: der FHS (siehe dort) erklrt warum dies eine Gute Idee ist.

Fr jedes Paket das eine Datei mit einer bestimmten Funktionalitt bereitstellt, wird bei der Installation, der nderung oder der Entfernung update-alternatives aufgerufen um die Informationen ber diese Datei im Alternativ-System zu aktualisieren. update-alternatives wird gewhnlich vom postinst oder prerm eines Debian-Paketes aufgerufen.

Es ist oft sinnvoll, dass eine Reihe von Alternativen synchronisiert werden, so dass sie als Gruppe gendert werden; wenn beispielsweise mehrere Versionen des vi(1) Editors installiert sind, sollte die Handbuchseite, die durch /usr/share/man/man1/vi.1 referenziert wird, zu dem ausfhrbaren Programm, dass durch /usr/bin/vi referenziert wird, gehren. update-alternatives erledigt dies mit Hilfe von Master- und Slave-Links; wird der Master-Link gendert, wird auch jeder zugehrige Slave-Link gendert. Ein Master-Link und seine zugehrigen Slave-Links bilden zusammen eine Link-Gruppe.

Eine Linkgruppe ist zu jeder Zeit in einer der beiden Modi: automatisch oder manuell. Ist eine Gruppe im automatischen Modus, dann wird das Alternativ-System bei der Paketinstallation und -entfernung automatisch entscheiden, ob und wie die Links aktualisiert werden. Im manuellen Modus ndert das Alternativ-System die Links nicht; die Entscheidung verbleibt beim Systemadministrator.

Beim erstmaligen Auftreten im System befindet sich eine Linkgruppe im automatischen Modus. Fhrt der Systemadministrator nderungen an den automatischen Einstellungen durch, wird dies beim nchsten Aufruf von update-alternatives auf die Linkgruppe bemerkt und die Gruppe wird automatisch in den manuellen Modus umgeschaltet.

Jede Alternative hat eine ihr zugeordnete Prioritt. Befindet sich eine Linkgruppe im automatischen Modus, zeigen die Mitglieder einer Gruppe auf die Alternative mit der hchsten Prioritt.

Wird die --config Option verwendet, dann zeigt update-alternatives alle Auswahlmglichkeiten fr die name der Master-Link ist an. Sie werden aufgefordert anzugeben, welche der Mglichkeiten fr die Linkgruppe verwendet werden soll. Sobald Sie eine nderung durchfhren, befindet sich die Linkgruppe nicht mehr im automatischen Modus. Sie mssen dann die --auto Option verwenden, um wieder in den automatischen Zustand zurckzukehren.

Falls Sie nichtinteraktiv konfigurieren mchten, knnen Sie stattdessen die --set Option verwenden (siehe unten).

BEGRIFFE
Da die Ttigkeiten von update-alternatives recht komplex sind sollen einige spezielle Begriffe helfen, seine Vorgehensweise zu erlutern.

generische Namen
    Ein Name wie /usr/bin/editor, der sich, ber das Alternativ-System, auf eine Reihe von Dateien mit hnlicher Funktionalitt bezieht.

Symlink
    Ohne weitere Angabe bedeutet dies ein symbolischer Link im Alternativ-Verzeichnis; einer derer, die vom Systemadministrator angepat werden sollen.

Alternative
    Der Name einer speziellen Datei im Dateisystem, die mittels eines generischen Namens ber das Alternativ-System zugreifbar gemacht werden kann.

Alternativ-Verzeichnis
    Ein Verzeichnis, standardmig /etc/alternatives, das die Symlinks enthlt.

administratives Verzeichnis
    Ein Verzeichnis, standardmig /var/lib/dpkg/alternatives, das die update-alternatives Statusinformationen enthlt.

Linkgruppe
    Ein Satz zusammengehrender Symlinks, die als Gruppe aktualisiert werden sollen.

Master-Link
    Der Link in einer Linkgruppe der bestimmt, wie die anderen Links in der Gruppe konfiguriert werden.

Slave-Link
    Ein Link in einer Gruppe der durch den Zustand des Master-Links bestimmt wird.

automatischer Modus
    Ist ein Link im automatischen Modus, dann sorgt das Alternativ-System dafr, dass die Links in der Gruppe auf die fr die Gruppe passende Alternative mit der hchsten Prioritt zeigen.

manueller Modus
    Ist eine Linkgruppe im manuellen Modus, dann fhrt das Alternativ-System keine nderungen an den Einstellungen des Systemadministrators durch.

BEISPIELE
Es gibt mehrere Pakete die einen zum vi kompatiblen Texteditor bereitstellen, beispielsweise nvi und vim. Welcher benutzt wird, wird durch die Linkgruppe vi eingestellt, was Links fr das Programm selber und die zugehrige Handbuchseite beinhaltet.

Um alle verfgbaren Programme anzuzeigen, die vi bereitstellen, und die dazu gehrigen Einstellungen, benutzen Sie die --display Aktion:

    update-alternatives --display vi

Um einen bestimmte vi Implementation auszuwhlen, benutzen Sie als Root den folgenden Befehl und whlen dann eine Zahl aus der Liste aus:

    update-alternatives --config vi

Damit die Implementation von vi wieder automatisch ausgewhlt wird, fhren Sie folgendes als root durch:

    update-alternatives --auto vi

OPTIONEN
Genau eine Aktion mu angegeben werden, falls update-alternatives eine sinnvolle Aufgabe erfllen soll. Eine beliebige Anzahl von allgemeinen Optionen kann zusammen mit jeder Aktion spezifiziert werden.

  ALLGEMEINE OPTIONEN

--verbose
    Erzeugt mehr Kommentare ber die Ttigkeit von update-alternatives.

--quiet
    Erzeugt keine Kommentare, es sei denn, ein Fehler tritt auf. Diese Option ist noch nicht implementiert.

--test
    Fhrt nichts durch, sondern teilt nur mit, was getan wrde. Diese Option ist noch nicht implementiert.

--help
    Gibt Hinweise zur Benutzung (und die Version von update-alternatives) aus.

--version
    Gibt die Version von update-alternatives aus (sowie Hinweise zur Benutzung).

--altdir Verzeichnis
    Spezifiziert das Alternativ-Verzeichnis, wenn sich dieses von der Standardeinstellung unterscheidet.

--admindir Verzeichnis
    Spezifiziert das administrative Verzeichnis, wenn sich dieses vom Standardwert unterscheiden soll.

  AKTIONEN

--install link gen pfad pri [--slave slink sgen spfad] ...
    Fgt eine Gruppe von Alternativen zum System hinzu. gen ist der generische Name des Master-Links, link ist der Name seines Symlinks, und pfad ist die Alternative, die fr den Master-Link eingefhrt wird. sgen, slink und spfad sind der generische Name, Symlink-Name und Alternative fr den Slave-Link. Null oder mehrere --slave Optionen, jede von drei Argumenten gefolgt, knnen spezifiziert werden.

    Falls der angegebene Master-Symlink bereits in den Datenstzen des Alternativ-Systems existiert, dann wird die angegebene Information als neuer Satz von Alternativen fr die Gruppe hinzugefgt. Andernfalls wird eine neue Gruppe im automatischen Modus mit dieser Information hinzugefgt. Falls die Gruppe im automatischen Modus ist, und die Prioritt der neu hinzugefgten Alternativen hher ist als alle installierten Alternativen fr diese Gruppe, dann werden die Symlinks aktualisiert, um auf die neu hinzugefgte Alternative zu zeigen.

--set name pfad
    Setzt das Programm pfad als Alternative fr name. Dies ist equivalent zu --config, kann aber geskriptet werden, da es nicht-interaktiv ist.

--remove name path
    Entfernt eine Alternative und alle zugehrigen Slave-Links. name ist der Name des Alternativ-Verzeichnisses, und pfad ist ein absoluter Dateiname zu dem name gelinkt werden kann. Falls name tatschlich nach pfad gelinkt ist, dann wird name aktualisiert um auf eine andere geeignete Alternative zu zeigen, oder entfernt, falls keine solche Alternative brig bleibt. Zugehrige Slave-Links werden entsprechend aktualisiert oder entfernt. Falls der Link derzeit nicht auf pfad zeigt, werden keine Links gendert; nur die Information ber die Alternative wird entfernt.

--remove-all name
    Entfernt alle Alternativen und ihre zugehrigen Slave-Links. name ist der Name des Alternativ-Verzeichnisses.

--all
    Ruft --config fr alle Alternativen auf.

--auto link
    befhrt den Master-Link link in den automatischen Modus. In diesem Proze wird dieser Symlink und seine Slave-Links aktualisiert, um auf die installierte Alternative mit hchster Prioritt zu zeigen.

--display link
    Zeigt Informationen ber die Linkgruppe an, von der link der Master-Link ist. Die angezeigten Informationen enthalten den Modus der Gruppe (automatisch oder manuell), auf welche Alternative der Symlink derzeit zeigt, welche weiteren Alternativen zur Verfgung stehen (und ihre zugehrigen Slave-Alternativen), und die installierte Alternative mit der hchsten Prioritt.

--list link
    Zeigt alle Ziele der Linkgruppe an.

--config link
    Zeit die verfgbaren Alternativen fr eine Linkgruppe an und erlaubt es dem Benutzer interaktiv auszuwhlen, welche zu benutzen ist. Die Linkgruppe wird aktualisiert und aus dem automatischen Modus genommen.

DATEIEN

/etc/alternatives/
    Das standardmige Alternativ-Verzeichnis. Kann mittels der --altdir Option gendert werden.

/var/lib/dpkg/alternatives/
    Das standardmige administrative Verzeichnis. Kann mittels der --admindir Option gendert werden.

EXIT-STATUS

0   Die angeforderte Aktion wurde erfolgreich beendet.

2   Beim Lesen der Kommandozeile oder beim Ausfhren der Aktion traten Probleme auf.

DIAGNOSTIK
update-alternatives quatscht ohne Unterlass ber seine Aktivitten auf der Standardausgabe. Falls ein Problem auftritt, gibt update-alternatives eine Fehlermeldung auf der Standardfehlerausgabe aus und beendet sich mit dem Exit-Status 2. Die Diagnostiks sollten selbsterklrend sein; falls Sie dies nicht so empfinden, melden Sie dies bitte als Fehler.

FEHLER
Falls Sie einen Fehler finden, melden Sie ihn bitte ber das Debian Fehlerverfolgungssystem, oder, falls dies nicht mglich ist, schicken Sie eine E-Mail direkt an den Autor.

Falls Sie einen Unterschied zwischen der Implementation von update-alternatives und dieser Handbuchseite finden, ist dies ein Fehler, entweder in der Implementation oder in der Dokumentation; bitte melden Sie dies.

AUTOR
Debian update-alternatives unterliegt dem Copyright 1995 von Ian Jackson. Es ist Freie Software; lesen Sie die GNU General Public License Version 2 oder neuer fr die Kopierbedingungen. Es gibt KEINE HAFTUNG.

Diese Handbuchseite unterliegt dem Copyright 1997/98 von Charles Briscoe-Smith. Dies ist Freie Dokumentation; lesen Sie die GNU General Public License Version 2 oder neuer fr die Kopierbedingungen. Es gibt KEINE HAFTUNG.

Die deutsche bersetzung wurde 2004 von Helge Kreutzmann <kreutzm@itp.uni-hannover.de> angefertigt. Diese bersetzung ist Freie Dokumentation; lesen Sie die GNU General Public License Version 2 oder neuer fr die Kopierbedingungen. Es gibt KEINE HAFTUNG.

Sie knne die GNU GPL auf Debian-Systemen unter /usr/share/common-licenses/GPL finden.

SIEHE AUCH
ln(1), FHS, der Dateisystem Hierachie-Standard (Filesystem Hierarchy Standard).